
require 'swf'

@f = Swf::Font.new "_serif"

@p = Swf::MovieClip.new

def label(string)
  t = Swf::TextField.new
  t.font = @f
  t.add_string string
  t.height = 200
  t.set_bounds 3200, 200
  t
end

def add_label(string)
  i = @p.add label string
  @p.next_frame
  @p.remove i
end

@p.add Swf::Action.new "stop();"
add_label "NO ACTION"
add_label "SWFBUTTON_MOUSEUP"
add_label "SWFBUTTON_MOUSEDOWN"
add_label "SWFBUTTON_MOUSEOVER"
add_label "SWFBUTTON_MOUSEOUT"
add_label "SWFBUTTON_MOUSEUPOUTSIDE"
add_label "SWFBUTTON_DRAGOVER"
add_label "SWFBUTTON_DRAGOUT"


def rect(r, g, b)
  s = Swf::Shape.new
  s.set_right_fill s.add_solid_fill r, g, b
  s.draw_line 600,0
  s.draw_line 0,600
  s.draw_line -600,0
  s.draw_line 0,-600
  s
end

b = Swf::Button.new
b.add_shape rect(0xff, 0, 0), Swf::Button::UP | Swf::Button::HIT
b.add_shape rect(0, 0xff, 0), Swf::Button::OVER
b.add_shape rect(0, 0, 0xff), Swf::Button::DOWN

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(1);"), Swf::Button::MOUSEUP

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(2);"), Swf::Button::MOUSEDOWN

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(3);"), Swf::Button::MOUSEOVER

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(4);"), Swf::Button::MOUSEOUT

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(5);"), Swf::Button::MOUSEUPOUTSIDE

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(6);"), Swf::Button::DRAGOVER

b.add_action Swf::Action.new("setTarget('/label'); gotoFrame(7);"), Swf::Button::DRAGOUT

@m = Swf::Movie.new
@m.set_dimension 4000, 3000

i = @m.add @p
i.name = "label"
i.move_to 400, 1900

i = @m.add b
i.move_to 400, 900

@m.save "test.swf"
