#include "init.h"

void
swf_no_rect()
{
	rb_raise(rb_eRuntimeError, "already closed rect");
}

static void
swf_free_rect(p)
	SWFRect p;
{
	Debug("swf free rect");
	destroySWFRect(p);
}

static VALUE
swf_rect_new(self, min_x, max_x, min_y, max_y)
	VALUE self, min_x, max_x, min_y, max_y;
{
	VALUE obj;
	
	SWFRect p;
	p = newSWFRect(
		NUM2INT(min_x),
		NUM2INT(max_x),
		NUM2INT(min_y),
		NUM2INT(max_y));
	obj = Data_Wrap_Struct(self, 0, swf_free_rect, p);
	return obj;
}

VALUE
swf_rect_alloc(self, p)
	VALUE self;
	SWFRect p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

void
swf_init_rect()
{
	cSwf_rect = rb_define_class_under(mSwf, "Rect", rb_cObject);
	rb_define_singleton_method(cSwf_rect, "new", swf_rect_new, 4);
}
